【POJ 1765】 November Rain(离散化+扫描线)

2023-10-25 13:59

本文主要是介绍【POJ 1765】 November Rain(离散化+扫描线),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

【POJ 1765】 November Rain(离散化+扫描线)

Time Limit: 5000MS Memory Limit: 65536K
Total Submissions: 2193 Accepted: 472
Case Time Limit: 2000MS

Description

Contemporary buildings can have very complicated roofs. If we take a vertical section of such a roof it results in a number of sloping segments. When it is raining the drops are falling down on the roof straight from the sky above. Some segments are completely exposed to the rain but there may be some segments partially or even completely shielded by other segments. All the water falling onto a segment as a stream straight down from the lower end of the segment on the ground or possibly onto some other segment. In particular, if a stream of water is falling on an end of a segment then we consider it to be collected by this segment.

For the purpose of designing a piping system it is desired to compute how much water is down from each segment of the roof. To be prepared for a heavy November rain you should count one liter of rain water falling on a meter of the horizontal plane during one second.

Task
Write a program that:

reads the description of a roof,
computes the amount of water down in one second from each segment of the roof,
writes the results.

Input

The first line of the input contains one integer n (1 <= n < = 40000) being the number of segments of the roof. Each of the next n lines describes one segment of the roof and contains four integers x1, y1, x2, y2 (0 <= x1, y1, x2, y2 < = 1000000, x1 < x2, y1<>y2) separated by single spaces. Integers x1, y1 are respectively the horizontal position and the height of the left end of the segment. Integers x2, y2 are respectively the horizontal position and the height of the right end of the segment. The segments don't have common points and there are no horizontal segments. You can also assume that there are at most 25 segments placed above any point on the ground level.

Output

The output consists of n lines. The i-th line should contain the amount of water (in liters) down from the i-th segment of the roof in one second.

Sample Input

6
13 7 15 6
3 8 7 7
1 7 5 6
5 5 9 3
6 3 8 2
9 6 12 8

Sample Output

2
4
2
11
0
3


题目大意:有n个屋檐 求积水量

积水量是指横向累计的水流长度(水流在该屋檐上覆盖的横坐标长度)

对于每个屋檐,还要累计上它上面的屋檐流下来的水量。

样例挺友好的,看样例看图应该就能明白




至于写法,我没用线段树维护。

先不考虑上面流下来的水量,从左往右,每当到一个新的横坐标,前一个横坐标到当前累计的水量会统计到当前位置最高的屋檐上。

题目中说同一个横坐标最多25个屋檐,那么就暴力啊……


对于流下来的水。在刚才跑的过程中,建立拓扑图,随便什么方法,建出来就好

然后从最上面流下来就好。。


代码如下:

#include <iostream>
#include <cmath>
#include <vector>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <queue>
#include <stack>
#include <list>
#include <algorithm>
#include <map>
#include <set>
#define LL long long
#define Pr pair<int,int>
#define fread() freopen("in.in","r",stdin)
#define fwrite() freopen("out.out","w",stdout)using namespace std;
const int INF = 0x3f3f3f3f;
const int msz = 10000;
const int mod = 1e9+7;
const double eps = 1e-8;struct Point
{LL x,y,id;bool ad;bool operator <(const struct Point a)const{return x == a.x? ad == a.ad? ad == 1? y < a.y: y > a.y: ad > a.ad: x < a.x;}
};int tmp[233];
bool vis[233];
Point pt[88888];
Point ptc[88888];
int down[88888];
int up[88888];
LL ans[44444];
int tp;double cal(int pos,LL x)
{pos <<= 1;return (pt[pos+1].y-pt[pos].y)*(x-pt[pos].x)*1.0/(pt[pos+1].x-pt[pos].x)+pt[pos].y;
}int main()
{//fread();//fwrite();int n;while(~scanf("%d",&n)){int tpp = 0;for(int i = 0; i < n; ++i){scanf("%lld%lld",&pt[tpp].x,&pt[tpp].y);pt[tpp].id = i;pt[tpp].ad = 1;ptc[tpp] = pt[tpp];tpp++;scanf("%lld%lld",&pt[tpp].x,&pt[tpp].y);pt[tpp].id = i;pt[tpp].ad = 0;ptc[tpp] = pt[tpp];tpp++;}sort(ptc,ptc+tpp);memset(ans,0,sizeof(ans));memset(vis,0,sizeof(vis));memset(down,-1,sizeof(down));memset(up,0,sizeof(up));tp = 0;int j,mx;for(int i = 0; i < tpp; ++i){//printf("------Step:%d x:%d y:%d---------\n",i,ptc[i].x,ptc[i].y);int id = ptc[i].id;if(i != 0 && ptc[i].x != ptc[i-1].x){mx = -1;for(j = 0; j < tp; ++j){if(!vis[j]) continue;if(mx == -1 || cal(tmp[j],ptc[i].x) > cal(mx,ptc[i].x)) mx = tmp[j];}//printf("mx:%d\n",mx);//printf("%d-%d %d-%d\n",pt[mx<<1].x,pt[mx<<1].y,pt[mx<<1|1].x,pt[mx<<1|1].y);if(mx != -1) ans[mx] += ptc[i].x-ptc[i-1].x;}mx = -1;if(ptc[i].ad){if(pt[id<<1].y < pt[id<<1|1].y){for(j = 0; j < tp; ++j){if(!vis[j]) continue;//printf("cmp:%f %d\n",cal(tmp[j],ptc[i].x),ptc[i].y);if(cal(tmp[j],ptc[i].x) < ptc[i].y*1.0 && (mx == -1 || cal(tmp[j],ptc[i].x) > cal(mx,ptc[i].x))) mx = tmp[j];}if(mx != -1){//printf("!!!!!!!!!get:%d\n",mx);down[id] = mx;up[mx]++;}}for(j = 0; j < tp; ++j)if(!vis[j]) break;if(j == tp) tmp[tp++] = id;else tmp[j] = id;vis[j] = 1;}else{for(j = 0; j < tp; ++j)if(vis[j] && tmp[j] == id) break;if(j == tp) --tp;vis[j] = 0;if(pt[id<<1].y > pt[id<<1|1].y){for(j = 0; j < tp; ++j){if(!vis[j]) continue;//printf("cmp:%f %d\n",cal(tmp[j],ptc[i].x),ptc[i].y);if(cal(tmp[j],ptc[i].x) < ptc[i].y*1.0 && (mx == -1 || cal(tmp[j],ptc[i].x) > cal(mx,ptc[i].x))) mx = tmp[j];}if(mx != -1){//printf("!!!!!!!!!get:%d\n",mx);down[id] = mx;up[mx]++;}}}}for(int i = 0; i < n; ++i){if(!up[i]){//printf("ID:%d\n",i);int id = i;LL ad = ans[i];while(down[id] != -1){ans[down[id]] += ad;up[down[id]]--;if(up[down[id]] > 0){break;}else up[down[id]]--;ad = ans[down[id]];id = down[id];}}}for(int i = 0; i < n; ++i)printf("%lld\n",ans[i]);}return 0;
}





这篇关于【POJ 1765】 November Rain(离散化+扫描线)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/283042

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i